searchData={"items":[{"type":"task","title":"mix rag.gen_eval","doc":"Generates an evaluation script\n\nGenerates a script to perform evaluation of the RAG system.\nThe script should be adapted to the specific use case.","ref":"Mix.Tasks.Rag.GenEval.html"},{"type":"task","title":"Example - mix rag.gen_eval","doc":"```bash\nmix rag.gen_eval\n```","ref":"Mix.Tasks.Rag.GenEval.html#module-example"},{"type":"task","title":"Options - mix rag.gen_eval","doc":"","ref":"Mix.Tasks.Rag.GenEval.html#module-options"},{"type":"task","title":"mix rag.gen_rag_module","doc":"Generates a module containing RAG related code\n\nGenerates a module with an ingestion pipeline and a retrieval and generation pipeline.","ref":"Mix.Tasks.Rag.GenRagModule.html"},{"type":"task","title":"Example - mix rag.gen_rag_module","doc":"```bash\nmix rag.gen_rag_module --vector-store \"pgvector\"\n```","ref":"Mix.Tasks.Rag.GenRagModule.html#module-example"},{"type":"task","title":"Options - mix rag.gen_rag_module","doc":"","ref":"Mix.Tasks.Rag.GenRagModule.html#module-options"},{"type":"task","title":"mix rag.gen_servings","doc":"Generates `Nx.Serving`s to run an embedding model and an LLM\n\nGenerates `Nx.Serving`s to run an embedding model and an LLM","ref":"Mix.Tasks.Rag.GenServings.html"},{"type":"task","title":"Example - mix rag.gen_servings","doc":"```bash\nmix rag.gen_servings\n```","ref":"Mix.Tasks.Rag.GenServings.html#module-example"},{"type":"task","title":"Options - mix rag.gen_servings","doc":"","ref":"Mix.Tasks.Rag.GenServings.html#module-options"},{"type":"task","title":"mix rag.install","doc":"Installs the rag library\n\nInstalls required dependencies and generates code to set you up to get started with your selected vector store.","ref":"Mix.Tasks.Rag.Install.html"},{"type":"task","title":"Example - mix rag.install","doc":"```bash\nmix rag.install --vector-store pgvector\n```","ref":"Mix.Tasks.Rag.Install.html#module-example"},{"type":"task","title":"Options - mix rag.install","doc":"","ref":"Mix.Tasks.Rag.Install.html#module-options"},{"type":"module","title":"Rag","doc":"A library to build RAG (Retrieval Augmented Generation) systems in Elixir.","ref":"Rag.html"},{"type":"module","title":"Introduction to RAG - Rag","doc":"RAG enhances the capabilities of language models by combining retrieval-based and generative approaches.\nTraditional language models often struggle with the following problems:\n\n- **Knowledge Cutoff**: Their knowledge is limited to a fixed point in time, making it difficult to provide up-to-date information.\n- **Hallucinations**: They may generate information that sounds confident but is entirely made up, leading to inaccurate responses.\n- **Contextual Relevance**: They struggle to provide responses that are contextually relevant to the user's query.\n\nRAG addresses these issues by retrieving relevant information from an external knowledge source before generating a response.\nThis retrieval-augmented approach ensures that the generated content is informed by the most current data, reducing the likelihood of hallucinations and improving the overall quality of the responses.\nBy integrating retrieval with generation, RAG enables more reliable and contextually relevant interactions, making it a valuable tool for applications that require accurate and informative language generation.\n\nCheck out [Getting Started](/notebooks/getting_started.livemd).","ref":"Rag.html#module-introduction-to-rag"},{"type":"module","title":"Installation - Rag","doc":"If [available in Hex](https://hex.pm/docs/publish), the package can be installed\nby adding `rag` to your list of dependencies in `mix.exs`:\n\n```elixir\ndef deps do\n  [\n    {:rag, \"~> 0.2.3\"}\n  ]\nend\n```\n\nThen, run `mix rag.install --vector-store  ` to install required dependencies and generate a RAG system that you can further customize to your needs.\n\nCurrently supported options for ` `:\n- `pgvector`\n- `chroma`\n\nBrought to you by [bitcrowd](https://bitcrowd.net/en).\n\n![bitcrowd logo](https://github.com/bitcrowd/rag/blob/main/.github/images/bitcrowd_logo.png?raw=true \"bitcrowd logo\")","ref":"Rag.html#module-installation"},{"type":"module","title":"Rag.Ai.Cohere","doc":"Implementation of `Rag.Ai.Provider` using the Cohere API.","ref":"Rag.Ai.Cohere.html"},{"type":"type","title":"Rag.Ai.Cohere.t/0","doc":"","ref":"Rag.Ai.Cohere.html#t:t/0"},{"type":"module","title":"Rag.Ai.Nx","doc":"Implementation of `Rag.Ai.Provider` using `Nx`.","ref":"Rag.Ai.Nx.html"},{"type":"type","title":"Rag.Ai.Nx.t/0","doc":"","ref":"Rag.Ai.Nx.html#t:t/0"},{"type":"module","title":"Rag.Ai.Ollama","doc":"Implementation of `Rag.Ai.Provider` using Ollama.","ref":"Rag.Ai.Ollama.html"},{"type":"type","title":"Rag.Ai.Ollama.t/0","doc":"","ref":"Rag.Ai.Ollama.html#t:t/0"},{"type":"module","title":"Rag.Ai.OpenAI","doc":"Implementation of `Rag.Ai.Provider` using the OpenAI API.","ref":"Rag.Ai.OpenAI.html"},{"type":"type","title":"Rag.Ai.OpenAI.t/0","doc":"","ref":"Rag.Ai.OpenAI.html#t:t/0"},{"type":"behaviour","title":"Rag.Ai.Provider","doc":"Behaviour for providers of AI capabilities.","ref":"Rag.Ai.Provider.html"},{"type":"type","title":"Rag.Ai.Provider.embedding/0","doc":"","ref":"Rag.Ai.Provider.html#t:embedding/0"},{"type":"callback","title":"Rag.Ai.Provider.generate_embeddings/3","doc":"Generates embeddings for `texts`.","ref":"Rag.Ai.Provider.html#c:generate_embeddings/3"},{"type":"callback","title":"Rag.Ai.Provider.generate_text/3","doc":"Generates a text for `prompt`.","ref":"Rag.Ai.Provider.html#c:generate_text/3"},{"type":"callback","title":"Rag.Ai.Provider.new/1","doc":"Creates a new provider struct.","ref":"Rag.Ai.Provider.html#c:new/1"},{"type":"type","title":"Rag.Ai.Provider.response/0","doc":"","ref":"Rag.Ai.Provider.html#t:response/0"},{"type":"module","title":"Rag.Embedding","doc":"Functions to generate embeddings.","ref":"Rag.Embedding.html"},{"type":"type","title":"Rag.Embedding.embedding/0","doc":"","ref":"Rag.Embedding.html#t:embedding/0"},{"type":"type","title":"Rag.Embedding.embeddings_function/0","doc":"","ref":"Rag.Embedding.html#t:embeddings_function/0"},{"type":"function","title":"Rag.Embedding.generate_embedding/2","doc":"Passes `generation.query` to `embeddings_function` or `provider` to generate an embedding.\nThen, puts the embedding in `generation.query_embedding`.","ref":"Rag.Embedding.html#generate_embedding/2"},{"type":"function","title":"Rag.Embedding.generate_embedding/3","doc":"Passes a text from `ingestion` to `embeddings_function` or `provider` to generate an embedding.\nThen, puts the embedding in `ingestion`.","ref":"Rag.Embedding.html#generate_embedding/3"},{"type":"function","title":"Options - Rag.Embedding.generate_embedding/3","doc":"* `text_key`: key which holds the text that is used to generate the embedding. Default: `:text`\n * `embedding_key`: key where the generated embedding is stored. Default: `:embedding`","ref":"Rag.Embedding.html#generate_embedding/3-options"},{"type":"function","title":"Rag.Embedding.generate_embeddings_batch/3","doc":"Passes all values of `ingestions` at `text_key` to `embeddings_function` or `provider` to generate all embeddings in a single batch.\nPuts the embeddings in `ingestions` at `embedding_key`.","ref":"Rag.Embedding.html#generate_embeddings_batch/3"},{"type":"function","title":"Options - Rag.Embedding.generate_embeddings_batch/3","doc":"* `text_key`: key which holds the text that is used to generate the embedding. Default: `:text`\n * `embedding_key`: key where the generated embedding is stored. Default: `:embedding`","ref":"Rag.Embedding.html#generate_embeddings_batch/3-options"},{"type":"type","title":"Rag.Embedding.provider/0","doc":"","ref":"Rag.Embedding.html#t:provider/0"},{"type":"module","title":"Rag.Evaluation","doc":"Functions to evaluate generations.","ref":"Rag.Evaluation.html"},{"type":"function","title":"Rag.Evaluation.detect_hallucination/2","doc":"Takes the values of `query`, `response` and `context` from `generation`, conproviders a prompt and passes it to `response_function` or `provider` to detect potential hallucinations.\nThen, puts a new `hallucination` evaluation in `generation.evaluations`.","ref":"Rag.Evaluation.html#detect_hallucination/2"},{"type":"function","title":"Rag.Evaluation.evaluate_rag_triad/2","doc":"Evaluates the response, query, and context according to the [RAG triad](https://www.trulens.org/getting_started/core_concepts/rag_triad/).\n- context relevance: is the retrieved context relevant to the query?\n- groundedness: is the response supported by the context?\n- answer relevance: is the answer relevant to the query?\n\nPrompts from https://github.com/truera/trulens/blob/main/src/feedback/trulens/feedback/prompts.py","ref":"Rag.Evaluation.html#evaluate_rag_triad/2"},{"type":"type","title":"Rag.Evaluation.provider/0","doc":"","ref":"Rag.Evaluation.html#t:provider/0"},{"type":"type","title":"Rag.Evaluation.response_function/0","doc":"","ref":"Rag.Evaluation.html#t:response_function/0"},{"type":"module","title":"Rag.Generation","doc":"Functions to generate a response and helpers to work with a generation struct.","ref":"Rag.Generation.html"},{"type":"function","title":"Rag.Generation.add_error/2","doc":"Appends an error to the existing list of errors.","ref":"Rag.Generation.html#add_error/2"},{"type":"function","title":"Rag.Generation.build_context/3","doc":"Passes `generation` and `opts` to `context_builder_function` to determine the context.\nThen, puts the context in `generation.context`.","ref":"Rag.Generation.html#build_context/3"},{"type":"function","title":"Rag.Generation.build_context_sources/3","doc":"Passes `generation` and `opts` to `context_sources_builder_function` to determine the context sources.\nThen, puts the context sources in `generation.context_sources`.","ref":"Rag.Generation.html#build_context_sources/3"},{"type":"function","title":"Rag.Generation.build_prompt/3","doc":"Passes `generation` and `opts` to `prompt_builder_function` to determine the prompt.\nThen, puts the prompt in `generation.prompt`.","ref":"Rag.Generation.html#build_prompt/3"},{"type":"type","title":"Rag.Generation.context_builder_function/0","doc":"","ref":"Rag.Generation.html#t:context_builder_function/0"},{"type":"type","title":"Rag.Generation.context_sources_builder_function/0","doc":"","ref":"Rag.Generation.html#t:context_sources_builder_function/0"},{"type":"type","title":"Rag.Generation.embedding/0","doc":"","ref":"Rag.Generation.html#t:embedding/0"},{"type":"function","title":"Rag.Generation.generate_response/3","doc":"Passes `generation.prompt` to `response_function` or `provider` to generate a response.\nIf successful, puts the result in `generation.response`.","ref":"Rag.Generation.html#generate_response/3"},{"type":"function","title":"Rag.Generation.get_evaluation/2","doc":"Gets the evaluation at `key` in `generation.evaluations`.","ref":"Rag.Generation.html#get_evaluation/2"},{"type":"function","title":"Rag.Generation.get_retrieval_result/2","doc":"Gets the retrieval result at `key` in `generation.retrieval_results`.","ref":"Rag.Generation.html#get_retrieval_result/2"},{"type":"function","title":"Rag.Generation.halt/1","doc":"Sets `halted?` to `true` to skip all remaining operations.","ref":"Rag.Generation.html#halt/1"},{"type":"function","title":"Rag.Generation.new/2","doc":"Creates a new generation struct from a query.","ref":"Rag.Generation.html#new/2"},{"type":"type","title":"Rag.Generation.prompt_builder_function/0","doc":"","ref":"Rag.Generation.html#t:prompt_builder_function/0"},{"type":"type","title":"Rag.Generation.provider/0","doc":"","ref":"Rag.Generation.html#t:provider/0"},{"type":"function","title":"Rag.Generation.put_context/2","doc":"Puts `context` in `generation.context`.","ref":"Rag.Generation.html#put_context/2"},{"type":"function","title":"Rag.Generation.put_context_sources/2","doc":"Puts `context_sources` in `generation.context_sources`.","ref":"Rag.Generation.html#put_context_sources/2"},{"type":"function","title":"Rag.Generation.put_evaluation/3","doc":"Puts `evaluation` at `key` in `generation.evaluations`.","ref":"Rag.Generation.html#put_evaluation/3"},{"type":"function","title":"Rag.Generation.put_prompt/2","doc":"Puts `prompt` in `generation.prompt`.","ref":"Rag.Generation.html#put_prompt/2"},{"type":"function","title":"Rag.Generation.put_query_embedding/2","doc":"Puts `query_embedding` in `generation.query_embedding`.","ref":"Rag.Generation.html#put_query_embedding/2"},{"type":"function","title":"Rag.Generation.put_response/2","doc":"Puts `response` in `generation.response`.","ref":"Rag.Generation.html#put_response/2"},{"type":"function","title":"Rag.Generation.put_retrieval_result/3","doc":"Puts `retrieval_result` at `key` in `generation.retrieval_results`.","ref":"Rag.Generation.html#put_retrieval_result/3"},{"type":"type","title":"Rag.Generation.response/0","doc":"","ref":"Rag.Generation.html#t:response/0"},{"type":"type","title":"Rag.Generation.response_function/0","doc":"","ref":"Rag.Generation.html#t:response_function/0"},{"type":"type","title":"Rag.Generation.t/0","doc":"Represents a generation, the main datastructure in `rag`.","ref":"Rag.Generation.html#t:t/0"},{"type":"module","title":"Rag.Loading","doc":"Functions to load and transform data from various sources and formats.","ref":"Rag.Loading.html"},{"type":"function","title":"Rag.Loading.load_file/1","doc":"Reads the file from the filepath at `source` in `ingestion` and puts it in `ingestion` at `document`.","ref":"Rag.Loading.html#load_file/1"},{"type":"module","title":"Rag.Retrieval","doc":"Functions to retrieve data and transform retrieval results.","ref":"Rag.Retrieval.html"},{"type":"function","title":"Rag.Retrieval.concatenate_retrieval_results/3","doc":"Gets the retrieval result for each key in `retrieval_result_keys` from `generation.retrieval_results`.\nThen, concatenates all results into a list at `output_key`.","ref":"Rag.Retrieval.html#concatenate_retrieval_results/3"},{"type":"function","title":"Rag.Retrieval.deduplicate/3","doc":"Deduplicates entries at `entries_keys` in `generation.retrieval_results`.\nTwo entries are considered duplicates if they hold the same value at **all** `unique_by_keys`.\nIn case of duplicates, the first entry is kept.","ref":"Rag.Retrieval.html#deduplicate/3"},{"type":"function","title":"Rag.Retrieval.reciprocal_rank_fusion/4","doc":"Gets the retrieval result for each key in `retrieval_result_keys_and_weights` from `generation.retrieval_results`.\nThen, applies [Reciprocal Rank Fusion](https://plg.uwaterloo.ca/~gvcormac/cormacksigir09-rrf.pdf) to combine the retrieval results into a single list at `output_key`.\nThere is no guaranteed order for results with the same score.","ref":"Rag.Retrieval.html#reciprocal_rank_fusion/4"},{"type":"function","title":"Options - Rag.Retrieval.reciprocal_rank_fusion/4","doc":"* `identity`: list of keys which define the identity of a result. Results with same `identity` will be fused.","ref":"Rag.Retrieval.html#reciprocal_rank_fusion/4-options"},{"type":"type","title":"Rag.Retrieval.retrieval_function/0","doc":"","ref":"Rag.Retrieval.html#t:retrieval_function/0"},{"type":"function","title":"Rag.Retrieval.retrieve/3","doc":"Calls `retrieval_function` with `generation` as only argument.\n`retrieval_function` must return either {:ok, retrieval_result} or {:error, error}.","ref":"Rag.Retrieval.html#retrieve/3"},{"type":"module","title":"Rag.Telemetry","doc":"Provides information about telemetry events.","ref":"Rag.Telemetry.html"},{"type":"function","title":"Rag.Telemetry.events/0","doc":"Lists all telemetry events.","ref":"Rag.Telemetry.html#events/0"},{"type":"extras","title":"README","doc":"# Rag\n\n<!-- README START -->\n\nA library to build RAG (Retrieval Augmented Generation) systems in Elixir.","ref":"readme.html"},{"type":"extras","title":"Introduction to RAG - README","doc":"RAG enhances the capabilities of language models by combining retrieval-based and generative approaches.\nTraditional language models often struggle with the following problems:\n\n- **Knowledge Cutoff**: Their knowledge is limited to a fixed point in time, making it difficult to provide up-to-date information.\n- **Hallucinations**: They may generate information that sounds confident but is entirely made up, leading to inaccurate responses.\n- **Contextual Relevance**: They struggle to provide responses that are contextually relevant to the user's query.\n\nRAG addresses these issues by retrieving relevant information from an external knowledge source before generating a response.\nThis retrieval-augmented approach ensures that the generated content is informed by the most current data, reducing the likelihood of hallucinations and improving the overall quality of the responses.\nBy integrating retrieval with generation, RAG enables more reliable and contextually relevant interactions, making it a valuable tool for applications that require accurate and informative language generation.\n\nCheck out [Getting Started](/notebooks/getting_started.livemd).","ref":"readme.html#introduction-to-rag"},{"type":"extras","title":"Installation - README","doc":"If [available in Hex](https://hex.pm/docs/publish), the package can be installed\nby adding `rag` to your list of dependencies in `mix.exs`:\n\n```elixir\ndef deps do\n  [\n    {:rag, \"~> 0.2.3\"}\n  ]\nend\n```\n\nThen, run `mix rag.install --vector-store  ` to install required dependencies and generate a RAG system that you can further customize to your needs.\n\nCurrently supported options for ` `:\n- `pgvector`\n- `chroma`\n\nBrought to you by [bitcrowd](https://bitcrowd.net/en).\n\n![bitcrowd logo](https://github.com/bitcrowd/rag/blob/main/.github/images/bitcrowd_logo.png?raw=true \"bitcrowd logo\")\n\n\n<!-- README END -->","ref":"readme.html#installation"},{"type":"extras","title":"CHANGELOG","doc":"# CHANGELOG","ref":"changelog.html"},{"type":"extras","title":"v0.2.3 - CHANGELOG","doc":"* Add `Rag.Ai.Ollama` as ollama provider\n* Add `build_context/3`, `build_context_sources/3`, `build_prompt/3` to enable full pipeline interface\n* Enable streaming of responses (@W3NDO, thank you for your contribution!)","ref":"changelog.html#v0-2-3"},{"type":"extras","title":"v0.2.2 - CHANGELOG","doc":"* Add `ref` to `Generation` for referencing in telemetry handler","ref":"changelog.html#v0-2-2"},{"type":"extras","title":"v0.2.1 - CHANGELOG","doc":"* fix credo issues in generator\n* helpful error for missing servings in nx provider\n* fix typespecs with optional fields\n* more robust fulltext search with postgres in generator","ref":"changelog.html#v0-2-1"},{"type":"extras","title":"v0.2.0 - CHANGELOG","doc":"* syntax updates\n* unified embedding, generation, and evaluation modules","ref":"changelog.html#v0-2-0"},{"type":"extras","title":"v0.1.0 - CHANGELOG","doc":"* initial release","ref":"changelog.html#v0-1-0"},{"type":"extras","title":"Getting Started","doc":"<!-- livebook:{\"persist_outputs\":true} -->\n\n# Getting Started\n\n```elixir\nMix.install([\n  {:rag, \"~> 0.2.0\"},\n  {:kino, \"~> 0.15.3\"}\n])\n```","ref":"getting_started.html"},{"type":"extras","title":"Basic Idea - Getting Started","doc":"The underlying idea of Retrieval Augmented Generation is that we provide an LLM with helpful context when we let it generate a response.\n\nSo, instead of starting the text generation from a plain question:\n\n> What was the weather like in Berlin on 2025-03-13?\n\nWe give it context and a question:\n\n> Context:\n> Weather in Berlin on 2025-03-13: Cloudy and around 8°C\n> \n> Question:\n> What was the weather like in Berlin on 2025-03-13?\n\nThis way it's much easier for the LLM to respond with correct information (assuming the information in the context is correct).\n\nThe remainder of this guide represents a very basic example how we can implement this idea.\nFor a more sophisticated example, you can run the installer with `mix rag.install` in an existing mix project and inspect the generated code.","ref":"getting_started.html#basic-idea"},{"type":"extras","title":"Ingestion - Getting Started","doc":"To be able to provide helpful context at the right time, we first store information somewhere in a way that we can easily find relevant pieces.\nWe call this process \"ingestion\".\n\nUsually you will store the information in a suitable database. You might want to calculate embeddings of the information to perform semantic search. In that case, you can use [`Rag.Embedding.generate_embedding/3`](https://hexdocs.pm/rag/Rag.Embedding.html#generate_embedding/3) or [`Rag.Embedding.generate_embeddings_batch/3`](https://hexdocs.pm/rag/Rag.Embedding.html#generate_embeddings_batch/3).\n\nGenerally speaking, `rag` leaves the ingestion process up to you.\nFor this guide we will use a simple map to store some weather data.\n\n```elixir\nweather_data = %{\n  \"berlin\" => %{\n    ~D[2025-03-13] => \"Cloudy and around 8°C\"\n  }\n}\n```\n\n<!-- livebook:{\"output\":true} -->\n\n```\n%{\"berlin\" => %{~D[2025-03-13] => \"Cloudy and around 8°C\"}}\n```","ref":"getting_started.html#ingestion"},{"type":"extras","title":"Retrieval - Getting Started","doc":"We want to work with user queries like:\n\n> What was the weather like in Berlin on 2025-03-13?\n\nOur next step is to find relevant information.\nOftentimes, we would calculate an embedding of the query, and then use that to perform a semantic search for relevant data.\nWe could also perform a text based search.\nThe code generated by `mix rag.install` gives you an example of how to combine both.\n\nIn this guide we will perform a lookup in our `weather_data`.\nFor the sake of simplicity, the user input must follow a strict format:\n\n> What was the weather like in [city] on [date]?\n\n```elixir\ncity_input = Kino.Input.text(\"city\", default: \"Berlin\")\ndate_input = Kino.Input.date(\"date\", default: ~D[2025-03-13])\n\nimport Kino.Shorts\n\ngrid([text(\"What was the weather like in\"), city_input, text(\"on\"), date_input, text(\"?\")])\n```\n\n```elixir\ncity = Kino.Input.read(city_input)\ndate = Kino.Input.read(date_input)\n\nquery = \"What was the weather like in #{city} on #{date}?\"\n```\n\n<!-- livebook:{\"output\":true} -->\n\n```\n\"What was the weather like in Berlin on 2025-03-13?\"\n```\n\nAlright, we have a user query.\nNext, we need a function to retrieve weather data.\nA retrieval function in `rag` must take a `Rag.Generation` struct as argument and return `{:ok, result}` or `{:error, error}`.\n\n```elixir\ncity_and_date_from_query = fn query -> query\n    |> String.trim_leading(\"What was the weather like in \")\n    |> String.trim_trailing(\"?\")\n    |> String.split(\" on \")\nend\n\nweather_by_city_and_date = fn generation ->\n    case city_and_date_from_query.(generation.query) do\n    [city, date] -> {:ok, weather_data[String.downcase(city)][Date.from_iso8601!(date)]}\n    _else -> {:error, :bad_format}\n  end\nend\n```\n\n<!-- livebook:{\"output\":true} -->\n\n```\n#Function<42.39164016/1 in :erl_eval.expr/6>\n```\n\nLet's test the function.\n\n```elixir\nRag.Generation.new(query) |> weather_by_city_and_date.()\n```\n\n<!-- livebook:{\"output\":true} -->\n\n```\n{:ok, \"Cloudy and around 8°C\"}\n```\n\nNice, we found something for Berlin on 2025-03-13.","ref":"getting_started.html#retrieval"},{"type":"extras","title":"Generation - Getting Started","doc":"While you can directly use your retrieval function and afterwards use `Rag.Generation.put_retrieval_result/3` to store the result in the `Rag.Generation` struct, you'll get telemetry events when you pass it as a callback to `Rag.Retrieval.retrieve/3`.\n\n```elixir\ngeneration =\n  Rag.Generation.new(query)\n  |> Rag.Retrieval.retrieve(:weather, &weather_by_city_and_date.(&1))\n```\n\n<!-- livebook:{\"output\":true} -->\n\n```\n%Rag.Generation{\n  query: \"What was the weather like in Berlin on 2025-03-13?\",\n  query_embedding: nil,\n  retrieval_results: %{weather: \"Cloudy and around 8°C\"},\n  context: nil,\n  context_sources: [],\n  prompt: nil,\n  response: nil,\n  evaluations: %{},\n  halted?: false,\n  errors: []\n}\n```\n\nNext, we take the retrieved information and construct a context for the LLM and store it in our `Rag.Generation` struct.\n\n```elixir\ncontext =\n  if weather = Rag.Generation.get_retrieval_result(generation, :weather) do\n    [city, date] = city_and_date_from_query.(generation.query)\n    \"Weather in #{String.capitalize(city)} on #{date}: #{weather}\"\n  end\n\ngeneration = Rag.Generation.put_context(generation, context)\n```\n\n<!-- livebook:{\"output\":true} -->\n\n```\n%Rag.Generation{\n  query: \"What was the weather like in Berlin on 2025-03-13?\",\n  query_embedding: nil,\n  retrieval_results: %{weather: \"Cloudy and around 8°C\"},\n  context: \"Weather in Berlin on 2025-03-13: Cloudy and around 8°C\",\n  context_sources: [],\n  prompt: nil,\n  response: nil,\n  evaluations: %{},\n  halted?: false,\n  errors: []\n}\n```\n\nNow, we construct a prompt that we will finally pass to the LLM.\n\n```elixir\nprompt =\n  if generation.context do\n    \"\"\"\n    Context: #{generation.context}\n    Question: #{generation.query}\n    \"\"\"\n  else\n    generation.query\n  end\n\ngeneration = Rag.Generation.put_prompt(generation, prompt)\n```\n\n<!-- livebook:{\"output\":true} -->\n\n```\n%Rag.Generation{\n  query: \"What was the weather like in Berlin on 2025-03-13?\",\n  query_embedding: nil,\n  retrieval_results: %{weather: \"Cloudy and around 8°C\"},\n  context: \"Weather in Berlin on 2025-03-13: Cloudy and around 8°C\",\n  context_sources: [],\n  prompt: \"Context: Weather in Berlin on 2025-03-13: Cloudy and around 8°C\\nQuestion: What was the weather like in Berlin on 2025-03-13?\\n\",\n  response: nil,\n  evaluations: %{},\n  halted?: false,\n  errors: []\n}\n```\n\nFor the last step, generating a response, we must first configure a `Rag.Ai.Provider`.\nWe'll use `Rag.Ai.Cohere` this time as you can get a [free trial key](https://docs.cohere.com/v2/docs/rate-limits).\n\nIf you're reading this in livebook, you can configure a secret `COHERE_API_KEY`.\n\n```elixir\napi_key = System.get_env(\"LB_COHERE_API_KEY\")\n\nprovider = Rag.Ai.Cohere.new(text_model: \"command-r-plus\", api_key: api_key)\n\nKino.nothing()\n```\n\nFinally, we can generate a response.\n\n```elixir\ngeneration = Rag.Generation.generate_response(generation, provider)\n\ngeneration.response\n```\n\n<!-- livebook:{\"output\":true} -->\n\n```\n\"The weather in Berlin on 2025-03-13 was cloudy, with temperatures hovering around 8°C.\"\n```\n\n<!-- livebook:{\"offset\":6971,\"stamp\":{\"token\":\"XCP.Bugh5ZG8ze9aZRbrSojxNhktXgm26RjiUsIB1h0vPmO_Rlokjp42e8xGj7eeqn099946r1VNrxQo0vRl4dmb7EndTY1BhdNMQjkrJIIbt4uU_6R40nSG1gM\",\"version\":2}} -->","ref":"getting_started.html#generation"}],"proglang":"elixir","content_type":"text/markdown","producer":{"name":"ex_doc","version":"0.36.1"}}